import meep as mp
import argparse
import math

# FILL THE <PLACEHOLDER>
# so that the axis of propagation is the x-axis
# and the results agree with the results in ../rtm_ex

def main(args):

    resolution = args.res

    dpml = 1              # PML thickness
    <PLACEHOLDER> = 10 + 2*dpml    
    cell_size = mp.Vector3(<PLACEHOLDER>)
    pml_layers = [<PLACEHOLDER>]

    wvl_min = <PLACEHOLDER>           # min wavelength
    wvl_max = <PLACEHOLDER>           # max wavelength
    fmin = 1/wvl_max        # min frequency
    fmax = 1/wvl_min        # max frequency
    fcen = 0.5*(fmin+fmax)  # center frequency
    df = fmax-fmin          # frequency width
    nfreq = <PLACEHOLDER>              # number of frequency bins

    # rotation angle (in degrees) of source: CCW around Y axis, 0 degrees along +Z axis
    theta_r = math.radians(args.theta)

    print("(I) :: theta = {}".format(args.theta))
    
    kx = <PLACEHOLDER>
    ky = <PLACEHOLDER>
    kz = <PLACEHOLDER>

    # plane of incidence is xz
    k = mp.Vector3(kx,ky,kz).scale(<PLACEHOLDER>)

    # if normal incidence, force number of dimensions to be 1
    if theta_r == 0:
        dimensions = 1
    else:
        dimensions = 3

    comp_E = <PLACEHOLDER>

    sources = [mp.Source(mp.GaussianSource(<PLACEHOLDER>), component=comp_E, center=mp.Vector3(<PLACEHOLDER>))]

    sim = mp.Simulation(cell_size=cell_size,
                        boundary_layers=pml_layers,
                        sources=sources,
                        k_point=k,
                        # dimensions=dimensions,
                        resolution=resolution)

    refl_fr = mp.FluxRegion(center=mp.Vector3(<PLACEHOLDER>))
    refl = sim.add_flux(fcen, df, nfreq, refl_fr)

    sim.run(until_after_sources=mp.stop_when_fields_decayed(50, comp_E, mp.Vector3(<PLACEHOLDER>), <PLACEHOLDER>))

    empty_flux = mp.get_fluxes(refl)
    empty_data = sim.get_flux_data( <PLACEHOLDER> )
    sim.reset_meep()

    # add a block with n=3.5 for the air-dielectric interface
    geometry = [mp.Block(mp.Vector3(<PLACEHOLDER>), center=mp.Vector3(<PLACEHOLDER>), material=mp.Medium(index=<PLACEHOLDER>))]

    sim = mp.Simulation( <PLACEHOLDER> )

    refl = sim.add_flux( <PLACEHOLDER> )
    sim.load_minus_flux_data(refl, empty_data)

    sim.run(until_after_sources=mp.stop_when_fields_decayed(50, comp_E, mp.Vector3(<PLACEHOLDER>), <PLACEHOLDER>))

    refl_flux = mp.get_fluxes(refl)
    freqs = mp.get_flux_freqs(refl)

    for i in range(nfreq):
        print("refl:, {}, {}, {}, {}".format(<PLACEHOLDER>))

if __name__ == '__main__':
    parser = argparse.ArgumentParser()
    parser.add_argument('-res', type=int, default=200, help='resolution (default: 200 pixels/um)')
    parser.add_argument('-theta', type=float, default=0, help='tilt angle of incident planewave around x-axis (default: 0 degrees)')
    args = parser.parse_args()
    main(args)
    
